﻿/*
# 	Apprendre à programmer en ActionScript 3
# 	A. Tasso
# 	Chapitre 10: Le traitement de données multimédias
# 	Les Tweens
# 	Fichier : IconeTweener.fla
# 	Classe :  Icone.as 
*/



//Définition de la classe Icone
package {
	// importer les Tweener de caurina
	import caurina.transitions.*;
	// importer la classe Sprite et Loader
	import flash.display.*;
	// Importer la classe MouseEvent
	import flash.events.*;
	// Pour charger la classe URLRequest
	import flash.net.URLRequest;



	// Définition de la classe Icone
	public class Icone extends Sprite {

		public var photo:Loader;
		private var numero:int;

		// Définition de la fonction constructeur ---------------------- Exercice 10.7
		public function Icone( url:String, num:int) {
			setNumero(num);
			setPhoto(url);
			buttonMode=true;
		}
		
		// Les fonctions en set  et en get  ---------------------- Exercice 10.7
		
		public function setNumero(tmp:String):void {
			numero = tmp;
		}
		public function getNumero():int {
			return numero;
		}
		
		private function setPhoto(tmp:String):void {
			photo= new Loader();
			photo.load(new URLRequest("../"+tmp));
			photo.contentLoaderInfo.addEventListener(Event.COMPLETE, auComplet);
		}
		
		// Emettre un événement Event.COMPLETE lorsque la photo est chargée    ---------------------- Exercice 10.7
		private function auComplet(evt:Event):void {
			dispatchEvent(new Event(Event.COMPLETE));
			addChildAt(photo,0);
			photo.content.x = -photo.width/2;
			photo.content.y = -photo.height/2;
			photo.addEventListener(MouseEvent.MOUSE_OVER, surOver);
			photo.addEventListener(MouseEvent.MOUSE_OUT, surOut);
		}
		private function surOver(e:MouseEvent):void {
			var cible:Loader = e.currentTarget as Loader;
			Tweener.addTween(cible, {scaleX:1.2, scaleY:1.2, time:0.8, transition:"easeOutExpo"});
		}
		
		private function surOut(e:MouseEvent):void {
			var cible:Loader = e.currentTarget as Loader;
			Tweener.addTween(cible, {scaleX:1, scaleY:1, time:1, transition:"easeOutElastic"});
		}
		
	
	}
}

		